#
# Conditional build:
%bcond_with	tests		# build and run tests (requires root)

Summary:	Checkpoint/restore functionality for Linux in userspace
Summary(pl.UTF-8):	Funkcja checkpoint/restore w przestrzeni użytkownika dla Linuksa
Name:		criu
Version:	2.5
Release:	1
License:	GPL v2 (tools), LGPL v2.1 (library)
Group:		Applications/System
Source0:	http://download.openvz.org/criu/%{name}-%{version}.tar.bz2
# Source0-md5:	5d5115454d110adb744e885d82d2c1f6
Patch0:		%{name}-python.patch
Patch1:		tests.patch
URL:		http://criu.org/
BuildRequires:	asciidoc
BuildRequires:	libcap-devel
BuildRequires:	libnl-devel >= 1:3.2
BuildRequires:	pkgconfig
BuildRequires:	protobuf
BuildRequires:	protobuf-c-devel
BuildRequires:	protobuf-devel
BuildRequires:	python >= 2
BuildRequires:	python-modules
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.697
BuildRequires:	sed >= 4.0
Requires:	%{name}-libs = %{version}-%{release}
Requires:	iproute2 >= 3.5
Requires:	uname(release) >= 3.11
ExclusiveArch:	%{x8664} %{arm} aarch64 ppc64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libexecdir	%{_prefix}/lib

%description
Checkpoint/Restore In Userspace, or CRIU, is a software tool for Linux
operating system. Using this tool, you can freeze a running
application (or part of it) and checkpoint it to a hard drive as a
collection of files. You can then use the files to restore and run the
application from the point it was frozen at. The distinctive feature
of the CRIU project is that it is mainly implemented in user space.

%description -l en.UTF-8
Checkpoint/Restore In Userspace, or CRIU (pronounced kree-oo, IPA:
/krɪʊ/, Russian: криу), is a software tool for Linux operating system.
Using this tool, you can freeze a running application (or part of it)
and checkpoint it to a hard drive as a collection of files. You can
then use the files to restore and run the application from the point
it was frozen at. The distinctive feature of the CRIU project is that
it is mainly implemented in user space.

%description -l pl.UTF-8
CRIU (Checkpoint/Restore In Userspace) to narzędzie programowe dla
systemu operacyjnego Linux. Przy jego użyciu można zamrozić działającą
aplikację (lub jej część) i zapisać migawkę na twardym dysku jako
zestaw plików. Następnie można użyć tych plików do odtworzenia i
uruchomienia aplikacji od miejsca, w którym została zamrożona.
Wyróżnikiem projektu CRIU jest to, że został zaimplementowany głównie
w przestrzeni użytkownika.

%package libs
Summary:	CRIU shared library
Summary(pl.UTF-8):	Biblioteka współdzielona CRIU
License:	LGPL v2.1
Group:		Libraries

%description libs
CRIU shared library.

%description libs -l pl.UTF-8
Biblioteka współdzielona CRIU.

%package devel
Summary:	Header files for CRIU library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki CRIU
License:	LGPL v2.1
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description devel
Header files for CRIU library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki CRIU.

%package -n python-pycriu
Summary:	Python interface to CRIU
Summary(pl.UTF-8):	Pythonowy interfejs do CRIU
Group:		Libraries/Python
Requires:	%{name}-libs = %{version}-%{release}

%description -n python-pycriu
Python interface to CRIU. This package contains also crit utility.

%description -n python-pycriu -l pl.UTF-8
Pythonowy interfejs do CRIU. Ten pakiet zawiera także narzędzie crit.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -i -e 's#-O2 -g#$(OPT)#g' Makefile

%build
%define _make_opts \\\
	DEB_HOST_MULTIARCH= \\\
	CC="%{__cc}" \\\
	OPT="%{rpmcppflags} %{rpmcflags}" \\\
	PREFIX=%{_prefix} \\\
	LIBDIR=%{_libdir} \\\
	LOGROTATEDIR=%{_sysconfdir}/logrotate.d \\\
	LIBEXECDIR=%{_libexecdir} \\\
	PYSITESCRIPTDIR=%{py_sitescriptdir} \\\
	MANDIR=%{_mandir} \\\
	WERROR=0 \\\
	V=1
%{__make}

%if %{with tests}
%{__make} test
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -p contrib/docker_cr.sh $RPM_BUILD_ROOT%{_libexecdir}/%{name}/scripts

# optional scripts, do not autogenerate bash dep
chmod -x $RPM_BUILD_ROOT%{_libexecdir}/%{name}/scripts/*.sh

%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%post   libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CREDITS README.md
%attr(755,root,root) %{_sbindir}/criu
%{_mandir}/man8/criu.8*
%dir %{_libexecdir}/%{name}
%dir %{_libexecdir}/%{name}/scripts
%attr(755,root,root) %{_libexecdir}/%{name}/scripts/systemd-autofs-restart.sh
%attr(755,root,root) %{_libexecdir}/%{name}/scripts/docker_cr.sh

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcriu.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libcriu.so.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcriu.so
%{_includedir}/criu
%{_pkgconfigdir}/criu.pc

%files -n python-pycriu
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/crit
%{py_sitescriptdir}/pycriu
%{py_sitescriptdir}/crit-0.0.1-py*.egg-info
%changelog
* Mon Aug 22 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/criu.git;a=log;h=master

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> a934924
- add tests bcond (requires root)

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 5929095
- package contrib/docker_cr.sh to libexec

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> a27aad5
- package systemd-autofs-restart.sh

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 10de574
- package contrib

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 6073a3d
- update arches, %{ix86} still fails in assembler

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 7a48cad
- use _make_opts not to repeat make opts for build/install

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> db5fa3a
- up to 2.5, update runtime deps

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 5c2bc50
- up to 2.4

* Sun Aug 21 2016 Elan Ruusamäe <glen@delfi.ee> 6e51e7f
- update BR

* Fri Jun 24 2016 Jakub Bogusz <qboosh@pld-linux.org> 83bc7f4
- updated to 2.3
- updated python patch
- system service dropped upstream (running as root is discouraged)

* Mon Nov 30 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 9a76cc9
- release 3 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 42abf07
- release 2 (by relup.sh)

* Sat Sep 12 2015 Jakub Bogusz <qboosh@pld-linux.org> e7b45b1
- updated to 1.7
- updated python patch

* Sun Apr 05 2015 Jakub Bogusz <qboosh@pld-linux.org> 1d80f33
- updated to 1.5.1
- added python patch (fixes python install dirs)
- package python-pycriu

* Sun Apr 05 2015 Jakub Bogusz <qboosh@pld-linux.org> e769518
- pl

* Mon Feb 16 2015 Tomasz Pala <gotar@pld-linux.org> af06864
- upgraded to 1.4

* Wed Nov 05 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ead9148
- seems to be x8664 (+ few non th architectures)

* Wed Nov 05 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> d0e0f9d
- rel 2; avoid DEB_HOST_MULTIARCH usage

* Wed Nov 05 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> aa51aa1
- up to 1.3.1

* Tue Nov 04 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 26c7c18
- release 2 (by relup.sh)

